﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using MVR.FileManagementSecure;
using UnityEngine.UI;

namespace JayJayWon
{
    public class TagsManifest
    {
        public HashSet<PluginTag> pluginTags { get; protected set; }
        protected Dictionary<string, PluginTag> pluginTagLabelDict;
        protected HashSet<PluginTagSet> registeredPluginTagSets;

        public int tagCount { get { return 0; } }

        public TagsManifest()
        {

        }

        public void StoreTagManifest()
        {

        }

        public void RegisterPluginTagSet(PluginTagSet tagSet)
        {

        }

        public PluginTag NewTag()
        {
            PluginTag pluginTag = new PluginTag("");
            return pluginTag;
        }

        public void DeleteTag(PluginTag pluginTag)
        {                    
        }

        public List<string> GetTagLabels()
        {
            return new List<string>();
        }

        public PluginTag GetTag(string tagLabel)
        {
            return null;
        }

        public string TryLabelSet(PluginTag pluginTag, string userSetLabel)
        {
            return userSetLabel;
        }
    }

    public class PluginTag
    {
        private JSONStorableString tagLabelJSON;
        public string tagLabel { get { return tagLabelJSON.val; } set { tagLabelJSON.val = value; } }
        public PluginTag(string label)
        {
            tagLabelJSON = new JSONStorableString("Tag", label);

        }
    }

    public class PluginTagSet
    {
        private PluginManifestEntry pme;
        protected Dictionary<PluginTag, bool> pluginTagsDict ;
        TagsManifest tagManifest;
        public PluginTagSet(TagsManifest _tagManifest, PluginManifestEntry _pme=null)
        {
            pluginTagsDict = new Dictionary<PluginTag, bool>();
        }

        public bool IsTagEnabled (PluginTag tag)
        {
            return (false);
        }

        public string GetTagSetSummary()
        {
            return "";
        }

        public JSONArray GetActiveTagsJSON()
        {
            JSONArray tagsArray = new JSONArray();
            return (tagsArray);
        }

        public void SetActiveTags(JSONArray tagsArray)
        {
        }

        public void ToggleTagValue(PluginTag tag)
        {
        }

        public void AddTag(PluginTag tag)
        {
            
        }

        public void RemoveTag(PluginTag tag)
        {
        }

        public void NotifyTagNameUpdate(PluginTag tag)
        {
        }
    }
}
